package com.gxwebsoft.tower.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.yulichang.wrapper.MPJLambdaWrapper;
import com.gxwebsoft.apps.entity.Equipment;
import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.Company;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.tower.entity.*;
import com.gxwebsoft.tower.service.TowerLendingSettleListService;
import com.gxwebsoft.tower.param.TowerLendingSettleListParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 拆借结算清单控制器
 *
 * @author 科技小王子
 * @since 2023-06-15 10:29:54
 */
@Api(tags = "拆借结算清单管理")
@RestController
@RequestMapping("/api/tower/tower-lending-settle")
public class TowerLendingSettleListController extends BaseController {
    @Resource
    private TowerLendingSettleListService towerLendingSettleListService;

    @PreAuthorize("hasAuthority('tower:towerLending:list')")
    @OperationLog
    @ApiOperation("分页查询拆借结算清单")
    @GetMapping("/page")
    public ApiResult<PageResult<TowerLendingSettleList>> page(TowerLendingSettleListParam param) {
        PageParam<TowerLendingSettleList, TowerLendingSettleListParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(towerLendingSettleListService.page(page, page.getWrapper()));
        // 使用关联查询
        //return success(towerLendingSettleListService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('tower:towerLending:list')")
    @OperationLog
    @ApiOperation("查询全部拆借结算清单")
    @GetMapping()
    public ApiResult<List<TowerLendingSettleList>> list(TowerLendingSettleListParam param) {
        MPJLambdaWrapper<TowerLendingSettleList> wrapper = new MPJLambdaWrapper<>();
        wrapper.selectAll(TowerLendingSettleList.class)
                .selectAs(TowerEquipment::getName, TowerEquipment::getEquipmentName)
                .select(TowerEquipment::getFactoryNo)
                .select(TowerEquipment::getFilingNo)
                .select(TowerEquipment::getEquipmentNo)
                .leftJoin(TowerEquipment.class, TowerEquipment::getEquipmentId, TowerLendingSettleList::getEquipmentId);
        PageParam<TowerLendingSettleList, TowerLendingSettleListParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(towerLendingSettleListService.list(wrapper));
        // 使用关联查询
        //return success(towerLendingSettleListService.listRel(param));
    }

    @PreAuthorize("hasAuthority('tower:towerLending:list')")
    @OperationLog
    @ApiOperation("根据id查询拆借结算清单")
    @GetMapping("/{id}")
    public ApiResult<TowerLendingSettleList> get(@PathVariable("id") Integer id) {
        return success(towerLendingSettleListService.getById(id));
        // 使用关联查询
        //return success(towerLendingSettleListService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('tower:towerLending:save')")
    @OperationLog
    @ApiOperation("添加拆借结算清单")
    @PostMapping()
    public ApiResult<?> save(@RequestBody TowerLendingSettleList towerLendingSettleList) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
            towerLendingSettleList.setUserId(loginUser.getUserId());
        }
        if (towerLendingSettleListService.save(towerLendingSettleList)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('tower:towerLending:update')")
    @OperationLog
    @ApiOperation("修改拆借结算清单")
    @PutMapping()
    public ApiResult<?> update(@RequestBody TowerLendingSettleList towerLendingSettleList) {
        if (towerLendingSettleListService.updateById(towerLendingSettleList)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('tower:towerLending:remove')")
    @OperationLog
    @ApiOperation("删除拆借结算清单")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (towerLendingSettleListService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('tower:towerLending:save')")
    @OperationLog
    @ApiOperation("批量添加拆借结算清单")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<TowerLendingSettleList> list) {
        QueryWrapper<TowerLendingSettleList> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("lending_id", list.get(0).getLendingId());
        towerLendingSettleListService.remove(queryWrapper);
        if (towerLendingSettleListService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('tower:towerLending:update')")
    @OperationLog
    @ApiOperation("批量修改拆借结算清单")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<TowerLendingSettleList> batchParam) {
        if (batchParam.update(towerLendingSettleListService, "lending_settle_list_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('tower:towerLending:remove')")
    @OperationLog
    @ApiOperation("批量删除拆借结算清单")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (towerLendingSettleListService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
